<!DOCTYPE html>
<html>

<head>
	<title>表建模</title>
	<#include "base/pageheader.ftl"/>
	<style>
		.ztree-wrap {
			overflow: auto;
		}
		
	
		.layui-card-body .layui-table{
			margin:0;
		}
		.layui-table-view {
			margin: 5px 0;
		}
		#rightButtonMenu {
			position: absolute;
			width: 110px;
			border: 1px solid #ccc;
			padding: 5px 0;
			display: block;
			box-shadow: 0 0 2px #ccc;
			font-size: 14px;
			border-radius: 3px;
			z-index: 10000;
			background: #fff;
			color: #000;
			box-sizing: border-box;
		}

		#rightButtonMenu li {
			height: 30px;
			line-height: 30px;
			padding: 0 18px 0 15px;
			cursor: pointer;
			position: relative;
		}

		#rightButtonMenu li:hover {
			background-color: #277FD0;
    		color: #fff;
		}
	</style>
</head>

<body>
	<div class="layui-fluid">
		<div class="layui-row  layui-col-space5">
			<div class="layui-col-md2 docking-left">
				<div class="layui-card docking-left">
				<div class="layui-card-header zltree-header">
					<div style="font-size: 12px;margin-bottom: 10px;color: #277FD0;">
						<img src="${request.contextPath}/static/image/mouse.png" alt="" style="vertical-align: sub;">鼠标右键可编辑模型信息
					</div>
				</div>
					<div class="layui-card-body zltree-body">
						<ul id="orgTreeId" class="ztree"  url="${request.contextPath}/manager/coretables/query"></ul>
					</div>
				</div>
			</div>

			<div class="layui-col-md10">
				<div class="layui-card docking-fill">
					<div class="layui-card-body">
						<form class="layui-form" id="frmTable" lay-filter="frmTable">
							<div class="layui-form-item">
								<div class="layui-col-md12 layui-hide ">
									<input type="text" class="layui-input" lay-filter="RWID" name="RWID">
								</div>
							</div>
							<div class="layui-form-item">
								<div class="layui-col-md6">
									<label class="layui-form-label">名称</label>
									<div class="layui-input-block">
										<input type="text" class="layui-input" lay-filter="MX_MINGC" disabled name="MX_MINGC" lay-verify="required"> </div>
								</div>
							</div>
							<div class="layui-form-item">
								<div class="layui-col-md6">
									<label class="layui-form-label">编号</label>
									<div class="layui-input-block">
										<input type="text" class="layui-input" lay-filter="MX_BIANH" disabled name="MX_BIANH" lay-verify="required"> </div>
								</div>
							</div>
							<div class="layui-form-item">
								<div class="layui-col-md6">
									<label class="layui-form-label">主键字段</label>
									<div class="layui-input-block">
										<input type="text" class="layui-input" lay-filter="MX_ZHUJZD" disabled name="MX_ZHUJZD"> </div>
								</div>
							</div>
							<div class="layui-form-item">
								<div class="layui-col-md6">
									<label class="layui-form-label">同步</label>
									<div class="layui-input-block">
										<input type="radio" lay-filter="MX_SHIFCJ" name="MX_SHIFCJ" disabled value="1" title="是">
										<div class="layui-unselect layui-form-radio layui-radio-disbaled layui-disabled">
											<i class="layui-anim layui-icon"></i>
											<div>是</div>
										</div>
										<input type="radio" lay-filter="MX_SHIFCJ" name="MX_SHIFCJ" disabled value="0" title="否">
										<div class="layui-unselect layui-form-radio layui-radio-disbaled layui-disabled">
											<i class="layui-anim layui-icon"></i>
											<div>否</div>
										</div>
									</div>
								</div>
							</div>
							<div class="layui-form-item">
								<div class="layui-col-md6">
									<label class="layui-form-label">模型类型 </label>
									<div class="layui-input-block">
										<select lay-filter="MX_BIAOLX" name="MX_BIAOLX" disabled zlcomponent class="select-ext" settings="{titlefield: 'VALUE', valuefield: 'CODE',dataurl:'${request.contextPath}/manager/coredictionary/querydictionarybyid?RWID=1589F6CBD7F94D5A85D206D18B1F41BE'}">
										</select>
									</div>
								</div>
							</div>
							<div class="layui-form-item">
								<div class="layui-col-md6 layui-hide ">
									<label class="layui-form-label">父节点</label>
									<div class="layui-input-block">
										<input type="text" class="layui-input" lay-filter="SYS_PARENTID" name="SYS_PARENTID"> </div>
								</div>
							</div>
							<div class="layui-form-item">
								<div class="layui-col-md6 layui-hide ">
									<label class="layui-form-label">是否叶子节点</label>
									<div class="layui-input-block">
										<input type="text" class="layui-input" lay-filter="SYS_ISLEAF " name="SYS_ISLEAF "> </div>
								</div>
							</div>
							<div class="layui-form-item">
								<div class="layui-col-md12 layui-hide ">
									<label class="layui-form-label">所有祖宗的</label>
									<div class="layui-input-block">
										<input type="text" class="layui-input" lay-filter="SYS_PARENTS" name="SYS_PARENTS"> </div>
								</div>
							</div>
						</form>
						<div class="layui-tab layui-tab-brief layui-col-md12">
							<ul class="layui-tab-title">
								<li class="layui-this">列表</li>
								<li>表索引</li>
							</ul>
							<div class="layui-tab-content">
								<div id="tabField" class="layui-tab-item layui-show">
									<div class="layui-col-md12">
										<table id="tbField" class="layui-table" lay-size="sm" lay-filter="tbField"></table>
									</div>
								</div>
								<div id="tabIndex" class="layui-tab-item">
									<div class="layui-col-md12">
										<table id="tbIndex" class="layui-table" lay-filter="tbIndex"></table>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
    </div>
    <!-- 文件导出 -->
    <div class="layui-hide" style="display:none">
        <form id="downloadform" action="" target="ifdownload" method="post">
        </form>
        <iframe id="ifdownload" name="ifdownload"></iframe>
    </div>
	<ul id="rightButtonMenu" class="layui-anim-fadein layui-anim layui-anim-upbit layui-hide">
		<li id="btnTreeNew">
			<i class="layui-icon layui-icon-add-1"></i>   
			新增
		</li>
		<li id="btnTreeEdit">
			<i class="layui-icon layui-icon-edit"></i>   
			修改
		</li>
		<li id="btnTreeDelete">
		<i class="layui-icon layui-icon-delete"></i>   
			删除
		</li>
	</ul>
	<script type="text/html" id="toolbarField">
		<div class="layui-btn-container">
			<button id="btnFieldNew" class="layui-btn layui-btn-sm" data-type="add" lay-event="addField">
				<i class="layui-icon layui-icon-add-circle-fine"></i>新增</button>
			<button id="btnFieldDelete" class="layui-btn layui-btn-sm" data-type="del" lay-event="deleteField">
				<i class="layui-icon layui-icon-delete"></i>删除</button>
			<button class="layui-btn layui-btn-sm" id="btnUpdateDB" lay-filter="btnUpdateDB" lay-event="updateFieldToDB">
				<i class="layui-icon layui-icon-table"></i>同步表结构</button>
			<button id="btnFieldExport" class="layui-btn layui-btn-sm" data-type="export" lay-event="exportField">
				<i class="layui-icon layui-icon-templeate-1"></i>导出列表</button>
		</div>
	</script>
	<script type="text/html" id="barField">
		<a class="layui-btn layui-btn-xs" lay-event="detail">查看</a>
		<a class="layui-btn layui-btn-xs" lay-event="edit">编辑</a>
		<a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="del">删除</a>
	  </script>
	  <script type="text/html" id="toolbarIndex">
		<div class="layui-btn-container">
			<button id="btnIndexNew" class="layui-btn layui-btn-sm" data-type="add" lay-event="addIndex">
				<i class="layui-icon layui-icon-add-circle-fine"></i>新增</button>
			<button id="btnIndexDelete" class="layui-btn layui-btn-sm" data-type="del" lay-event="deleteIndex">
				<i class="layui-icon layui-icon-delete"></i>删除</button>
		</div>
	</script>
	<script type="text/html" id="barIndex">
		<a class="layui-btn layui-btn-xs" lay-event="detail">查看</a>
		<a class="layui-btn layui-btn-xs" lay-event="edit">编辑</a>
		<a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="del">删除</a>
	  </script>
	<script type="text/html" id="barLink">
		<a class="layui-btn layui-btn-xs" lay-event="detail">查看</a>
		<a class="layui-btn layui-btn-xs" lay-event="edit">编辑</a>
		<a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="del">删除</a>
	  </script>
	<#include "base/pagefoot.ftl"/>
    <script type="text/javascript" src="${request.contextPath}/static/libs/ace/ace.js?v=<@configVersion suosxt='CORE'> </@configVersion>"></script>
	<script type="text/javascript" src="${request.contextPath}/static/modules/manager/coretable/coreTable.js?v=<@configVersion suosxt='CORE'> </@configVersion>"></script>

</body>

</html>