
<#--创建数据库-->
<#-- 输入参数 -->
<#--USER 数据库用户名 -->
<#--PASSWORD 数据库用户密码 -->
<#--DATABASENAME 数据库名 -->
<#--DATABASEDIR 数据库存放路径-->

CREATE DATABASE ${DATABASENAME}
ON PRIMARY                      --配置主数据文件的选项
(
    NAME='${DATABASENAME}',     --主数据文件的逻辑名称
    FILENAME='${DATABASENAME}\${DATABASENAME}.MDF',     --主数据文件的实际保存路径
    SIZE=5MB,                   --主文件的初始大小
    MAXSIZE=150MB,              --最大容量
    FILEGROWTH=20%              --以20%扩容
)
LOG ON                          --配置日志文件的选项
(
    NAME='${DATABASENAME}_LOG', --日志文件的逻辑名称
    FILENAME=' ${DATABASENAME}\${DATABASENAME}_LOG.LDF', --日志文件的实际保存路径
    SIZE=5MB,                   --日志文件的初始大小
    FILEGROWTH=5MB              --超过默认值后自动再扩容5MB
)

-- 创建用户
CREATE LOGIN ${USER} WITH PASSWORD='${PASSWORD}', DEFAULT_DATABASE=${DATABASENAME}
-- 授权
CREATE USER ${USER} FOR LOGIN ${USER} WITH DEFAULT_SCHEMA=dbo
exec sp_addrolemember 'db_owner', '${USER}';